using System;
using System.Collections.Generic;
using System.IO;
using UnityEngine;
using UnityEngine.Events;

namespace Mod
{
    //not used by the mod, but made for spreading the word of this
    //thanks to pjstarr12 for making this!
    public struct ChemistryAPI 
    { 
        public static void AddLiquidToItem(string ExistingItem, string NewLiquidID, float LiquidAmount) 
        { 
            ModAPI.FindSpawnable(ExistingItem).Prefab.AddComponent<FlaskBehaviour>();
            ModAPI.FindSpawnable(ExistingItem).Prefab.GetComponent<FlaskBehaviour>().StartLiquid = new BloodContainer.SerialisableDistribution 
            { 
                LiquidID = NewLiquidID,
                Amount = LiquidAmount
            };
        }
        //ChemistryAPI.AddLiquidToItem("Rotor","OIL",0.28f);

        public static void LiquidReaction(string FirstLiquid, string SecondLiquid, string TargetLiquid) 
        { 
            var mixer = new LiquidMixInstructions(
                Liquid.GetLiquid(FirstLiquid), 
                Liquid.GetLiquid(SecondLiquid),                         
                Liquid.GetLiquid(TargetLiquid));                   

            LiquidMixingController.MixInstructions.Add(mixer);  
        }
        //ChemistryAPI.LiquidReaction("LIFE SERUM","TRITIUM","INSTANT DEATH POISON");

        public static void TripleLiquidReaction(string FirstLiquid, string SecondLiquid, string ThirdLiquid, string TargetLiquid) 
        { 
            var mixer = new LiquidMixInstructions(
                Liquid.GetLiquid(FirstLiquid), 
                Liquid.GetLiquid(SecondLiquid),
                Liquid.GetLiquid(ThirdLiquid),                         
                Liquid.GetLiquid(TargetLiquid));                   

            LiquidMixingController.MixInstructions.Add(mixer);  
        }
        //ChemistryAPI.LiquidReaction("SUGAR","SPICE","EVERYTHING NICE","THE PERFECT LITTLE GIRL");
    }
}