using System;
using System.Collections.Generic;
using System.IO;
using UnityEngine;
using UnityEngine.Events;

//You're curious, aren't you?
//Just do not spoil it okay? Or at least act like you found the mixes without downloading, win-win.
//If you just want to learn a thing or two from the code then gl with that! It is not open-source, but you are free to copy concepts like the ChemistryAPI
//Do not rip this mod off however...

namespace Mod
{
    public class Mod
    {
        public static void Main()
        {            
            //CategoryBuilder.Create("DCM Liquids", "(Disclaimer: This category is as of now empty, but it will be filled up with items later. All the liquids as of now are mystery liquids, i.e. like exotic liquid & co.) \nYou're currently running version <b><color=#00bfbf>1.1.0</color></b>.", ModAPI.LoadSprite("Textures/Mod/Category Icon.png"));

            const string ResidueID = "RESIDUE";
            ModAPI.RegisterLiquid(ResidueID, new Residue());
            const string PermanentDeathPoisonID = "PERMANENT DEATH POISON";
            ModAPI.RegisterLiquid(PermanentDeathPoisonID, new PermanentDeathPoison());
            const string GillsSerumID = "GILLS SERUM";
            ModAPI.RegisterLiquid(GillsSerumID, new GillsSerum());
            const string ComaPoisonID = "COMA POISON";
            ModAPI.RegisterLiquid(ComaPoisonID, new ComaPoison());
            const string EnhancedAdrenalineID = "ENHANCED ADRENALINE";
            ModAPI.RegisterLiquid(EnhancedAdrenalineID, new EnhancedAdrenaline());

            const string EnhancedCoagulationSerumID = "ENHANCED COAGULATION SERUM";
            ModAPI.RegisterLiquid(EnhancedCoagulationSerumID, new EnhancedCoagulationSerum());
            const string AeternavitaSerumID = "AETERNAVITA SERUM";
            ModAPI.RegisterLiquid(AeternavitaSerumID, new AeternavitaSerum());
            const string InternalBleedingPoisonID = "INTERNAL BLEEDING POISON";
            ModAPI.RegisterLiquid(InternalBleedingPoisonID, new InternalBleedingPoison());
            const string BleedingPoisonID = "BLEEDING POISON";
            ModAPI.RegisterLiquid(BleedingPoisonID, new BleedingPoison());
            const string BoneHealingSerumID = "BONE HEALING SERUM";
            ModAPI.RegisterLiquid(BoneHealingSerumID, new BoneHealingSerum());

            const string VitamineDSerumID = "VITAMINE D SERUM";
            ModAPI.RegisterLiquid(VitamineDSerumID, new VitamineDSerum());
            const string NeutralizedReanimationAgentID = "NEUTRALIZED REANIMATION AGENT";
            ModAPI.RegisterLiquid(NeutralizedReanimationAgentID, new NeutralizedReanimationAgent());
            const string PartialReanimationAgentAntidoteID = "PARTIAL REANIMATION AGENT ANTIDOTE";
            ModAPI.RegisterLiquid(PartialReanimationAgentAntidoteID, new PartialReanimationAgentAntidote());
            const string ReanimationAgentAntidoteID = "REANIMATION AGENT ANTIDOTE";
            ModAPI.RegisterLiquid(ReanimationAgentAntidoteID, new ReanimationAgentAntidote());
            const string ElectricalFluidID = "ELECTRICAL FLUID";
            ModAPI.RegisterLiquid(ElectricalFluidID, new ElectricalFluid());

            const string DecimatorFluidID = "DECIMATOR FLUID";
            ModAPI.RegisterLiquid(DecimatorFluidID, new DecimatorFluid());
            const string LiquidBlackHoleID = "LIQUID BLACK HOLE";
            ModAPI.RegisterLiquid(LiquidBlackHoleID, new LiquidBlackHole());
            const string StatuePoisonID = "STATUE POISON";
            ModAPI.RegisterLiquid(StatuePoisonID, new StatuePoison());
            const string UltraStrengthSerumPlusID = "ULTRA STRENGTH SERUM+";
            ModAPI.RegisterLiquid(UltraStrengthSerumPlusID, new UltraStrengthSerumPlus());
            const string UltraWeaknessPoisonID = "ULTRA WEAKNESS POISON";
            ModAPI.RegisterLiquid(UltraWeaknessPoisonID, new UltraWeaknessPoison());

            const string ConventionalLiquidID = "CONVENTIONAL LIQUID";
            ModAPI.RegisterLiquid(ConventionalLiquidID, new ConventionalLiquid());
            const string PoisonID = "POISON";
            ModAPI.RegisterLiquid(PoisonID, new Poison());
            const string ConfusionAgentID = "CONFUSION AGENT";
            ModAPI.RegisterLiquid(ConfusionAgentID, new ConfusionAgent());
            const string RottingAgentID = "ROTTING AGENT";
            ModAPI.RegisterLiquid(RottingAgentID, new RottingAgent());
            const string BreathingSerumID = "BREATHING SERUM";
            ModAPI.RegisterLiquid(BreathingSerumID, new BreathingSerum());

            const string SuffocationAgentID = "SUFFOCATION AGENT";
            ModAPI.RegisterLiquid(SuffocationAgentID, new SuffocationAgent());
            const string TissueReconstructionAgentID = "TISSUE RECONSTRUCTION AGENT";
            ModAPI.RegisterLiquid(TissueReconstructionAgentID, new TissueReconstructionAgent());
            const string AntivenomID = "ANTIVENOM";
            ModAPI.RegisterLiquid(AntivenomID, new Antivenom());
            const string DerotifierSerumID = "DEROTIFIER SERUM™";
            ModAPI.RegisterLiquid(DerotifierSerumID, new DerotifierSerum());
            const string PainkillerAgentID = "PAINKILLER AGENT";
            ModAPI.RegisterLiquid(PainkillerAgentID, new PainkillerAgent());

            const string PainkillerSerumID = "PAINKILLER SERUM";
            ModAPI.RegisterLiquid(PainkillerSerumID, new PainkillerSerum());
            const string PainAgentID = "PAIN AGENT";
            ModAPI.RegisterLiquid(PainAgentID, new PainAgent());
            const string MagnaDoloreID = "MAGNA DOLORE";
            ModAPI.RegisterLiquid(MagnaDoloreID, new MagnaDolore());


            //ChemistryAPI.AddLiquidToItem("","",2.8f);
            ChemistryAPI.AddLiquidToItem("Stormbaan","ELECTRICAL FLUID",1.4f);
            ModAPI.FindSpawnable("Stormbaan").Prefab.AddComponent<StormBaanBehaviour>();
            ChemistryAPI.AddLiquidToItem("Decimator","DECIMATOR FLUID",2.8f);
            ModAPI.FindSpawnable("Decimator").Prefab.AddComponent<DecimatorFluidBehaviour>();
            ChemistryAPI.AddLiquidToItem("Disassembler","DECIMATOR FLUID",1.4f);
            ModAPI.FindSpawnable("Disassembler").Prefab.AddComponent<DecimatorFluidBehaviour>();

            
            //ChemistryAPI.LiquidReaction("","","");
            ChemistryAPI.LiquidReaction("INSTANT DEATH POISON","EXOTIC LIQUID","PERMANENT DEATH POISON");
            ChemistryAPI.LiquidReaction("WATER BREATHING SERUM","MENDING SERUM","GILLS SERUM");
            ChemistryAPI.LiquidReaction("KNOCKOUT POISON","EXOTIC LIQUID","COMA POISON");
            ChemistryAPI.LiquidReaction("ADRENALINE","EXOTIC LIQUID","ENHANCED ADRENALINE");
            ChemistryAPI.LiquidReaction("COAGULATION SERUM","EXOTIC LIQUID","ENHANCED COAGULATION SERUM");

            ChemistryAPI.LiquidReaction("LIFE SERUM","MENDING SERUM","AETERNAVITA SERUM");
            ChemistryAPI.LiquidReaction("LIFE SERUM","EXOTIC LIQUID","AETERNAVITA SERUM");
            ChemistryAPI.LiquidReaction("IMMORTALITY SERUM","EXOTIC LIQUID","AETERNAVITA SERUM");
            ChemistryAPI.LiquidReaction("COAGULATION SERUM","TRITIUM","INTERNAL BLEEDING POISON");
            ChemistryAPI.LiquidReaction("INTERNAL BLEEDING POISON","EXOTIC LIQUID","BLEEDING POISON");
            
            ChemistryAPI.LiquidReaction("BONE EATING POISON","TRITIUM","BONE HEALING SERUM");
            ChemistryAPI.LiquidReaction("BONE HEALING SERUM","EXOTIC LIQUID","VITAMINE D SERUM");
            ChemistryAPI.LiquidReaction("REANIMATION AGENT","TRITIUM","NEUTRALIZED REANIMATION AGENT");
            ChemistryAPI.LiquidReaction("NEUTRALIZED REANIMATION AGENT","MENDING SERUM","PARTIAL REANIMATION AGENT ANTIDOTE");
            ChemistryAPI.LiquidReaction("PARTIAL REANIMATION AGENT ANTIDOTE","EXOTIC LIQUID","REANIMATION AGENT ANTIDOTE");

            ChemistryAPI.LiquidReaction("DECIMATOR FLUID","ELECTRICAL FLUID","LIQUID BLACK HOLE");            
            ChemistryAPI.LiquidReaction("FREEZE POISON","EXOTIC LIQUID","STATUE POISON");
            ChemistryAPI.LiquidReaction("ULTRA STRENGTH SERUM","EXOTIC LIQUID","ULTRA STRENGTH SERUM+");
            ChemistryAPI.LiquidReaction("ULTRA STRENGTH SERUM","TRITIUM","ULTRA WEAKNESS POISON");
            ChemistryAPI.LiquidReaction("EXOTIC LIQUID","DECIMATOR FLUID","CONVENTIONAL LIQUID");

            ChemistryAPI.LiquidReaction("INSTANT DEATH POISON","CONVENTIONAL LIQUID","POISON");
            ChemistryAPI.LiquidReaction("KNOCKOUT POISON","CONVENTIONAL LIQUID","CONFUSION AGENT");
            ChemistryAPI.LiquidReaction("REANIMATION AGENT","CONVENTIONAL LIQUID","ROTTING AGENT");
            ChemistryAPI.LiquidReaction("WATER BREATHING SERUM","DECIMATOR FLUID","BREATHING SERUM");
            ChemistryAPI.LiquidReaction("BREATHING SERUM","TRITIUM","SUFFOCATION AGENT");

            ChemistryAPI.LiquidReaction("ACID","TRITIUM","TISSUE RECONSTRUCTION AGENT");
            ChemistryAPI.LiquidReaction("TISSUE DECONSTRUCTION AGENT","TRITIUM","TISSUE RECONSTRUCTION AGENT");
            ChemistryAPI.LiquidReaction("POISON","TRITIUM","ANTIVENOM");
            ChemistryAPI.LiquidReaction("ROTTING AGENT","TRITIUM","DEROTIFIER SERUM™");
            ChemistryAPI.LiquidReaction("MENDING SERUM","CONVENTIONAL LIQUID","PAINKILLER AGENT");

            ChemistryAPI.LiquidReaction("PAINKILLER AGENT","EXOTIC LIQUID","PAINKILLER SERUM");
            ChemistryAPI.LiquidReaction("PAINKILLER AGENT","TRITIUM","PAIN AGENT");
            ChemistryAPI.LiquidReaction("PAIN AGENT","EXOTIC LIQUID","MAGNA DOLORE");
            ChemistryAPI.LiquidReaction("PAINKILLER SERUM","TRITIUM","MAGNA DOLORE");


            ChemistryAPI.LiquidReaction("COAGULATION SERUM","BLEEDING POISON","RESIDUE");
            ChemistryAPI.LiquidReaction("ENHANCED COAGULATION SERUM","BLEEDING POISON","RESIDUE");
            ChemistryAPI.LiquidReaction("AETERNAVITA SERUM","PERMANENT DEATH POISON","RESIDUE");
            ChemistryAPI.LiquidReaction("ENHANCED ADRENALINE","COMA POISON","RESIDUE");
            ChemistryAPI.LiquidReaction("BONE EATING POISON","VITAMINE D SERUM","RESIDUE");


            ChemistryAPI.LiquidReaction("LIFE SERUM","TRITIUM","INSTANT DEATH POISON");
            ChemistryAPI.LiquidReaction("ADRENALINE","TRITIUM","KNOCKOUT POISON");


            //Currently unpossible with current knowledge
            //ModAPI.Register(
            //new Modification()
            //{
            //    OriginalItem = ModAPI.FindSpawnable("Flask"),
            //    NameOverride = "Specialized Cooling Flask [DCM]",
            //    DescriptionOverride = "What if the cooling element and flask had a baby? \nBut why? Why would you do that, why would you do any of that?",
            //    CategoryOverride = ModAPI.FindCategory("Chemistry"),
            //    ThumbnailOverride = ModAPI.LoadSprite("Textures/Views/Placeholder.png"),
            //    AfterSpawn = (Instance) =>
            //    {
            //        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/Chemistry/Specialized Flask.png");
            //        Instance.FixColliders();
            //    }
            //});
        }
    }

    //thanks to pjstarr12 for making this!
    public struct ChemistryAPI 
    { 
        public static void AddLiquidToItem(string ExistingItem, string NewLiquidID, float LiquidAmount) 
        { 
            ModAPI.FindSpawnable(ExistingItem).Prefab.AddComponent<FlaskBehaviour>();
            ModAPI.FindSpawnable(ExistingItem).Prefab.GetComponent<FlaskBehaviour>().StartLiquid = new BloodContainer.SerialisableDistribution 
            { 
                LiquidID = NewLiquidID,
                Amount = LiquidAmount
            };
        }

        public static void LiquidReaction(string FirstLiquid, string SecondLiquid, string TargetLiquid) 
        { 
            var mixer = new LiquidMixInstructions(
                Liquid.GetLiquid(FirstLiquid), 
                Liquid.GetLiquid(SecondLiquid),                         
                Liquid.GetLiquid(TargetLiquid));                   

            LiquidMixingController.MixInstructions.Add(mixer);  
        }
        public static void TripleLiquidReaction(string FirstLiquid, string SecondLiquid, string ThirdLiquid, string TargetLiquid) 
        { 
            var mixer = new LiquidMixInstructions(
                Liquid.GetLiquid(FirstLiquid), 
                Liquid.GetLiquid(SecondLiquid),
                Liquid.GetLiquid(ThirdLiquid),                         
                Liquid.GetLiquid(TargetLiquid));                   

            LiquidMixingController.MixInstructions.Add(mixer);  
        }
    }

    public class StormBaanBehaviour : MonoBehaviour
    {
    }
    public class DecimatorFluidBehaviour : MonoBehaviour
    {
    }
}