using System;
using System.Collections.Generic;
using System.IO;
using UnityEngine;
using UnityEngine.Events;

namespace Mod
{
    public class ExampleSyringe : SyringeBehaviour
    {
        public override string GetLiquidID() => ExampleSerum.ID;

        public class ExampleSerum : Liquid
        {
            public const string ID = "EXAMPLE SERUM";

            public ExampleSerum()
            {
                Color = new UnityEngine.Color(0.69f, 1f, 0.35f);
            }

            public override void OnEnterLimb(LimbBehaviour limb)
            {
            }

            public override void OnUpdate(BloodContainer container) 
            {
            }

            public override void OnEnterContainer(BloodContainer container) 
            {
            }

            public override void OnExitContainer(BloodContainer container) 
            {
            }
        }
    }
    public class ExampleFlaskSerum : Liquid
    {
        public ExampleFlaskSerum()
        {
            Color = new Color(0.79f, 0.89f, 0.83f);
        }

        public override void OnEnterContainer(BloodContainer container)
        {            
        }

        public override void OnEnterLimb(LimbBehaviour limb)
        {
        }

        public override void OnUpdate(BloodContainer container)
        {
        }
    
        public override void OnExitContainer(BloodContainer container)
        {            
        }
    }    
}